/******************************************************************************************************************
*	Author:				Jacquelin POTIER
*	Date:				10/31/2002
*	Copyright:			 2002, Jacquelin POTIER (jacquelin.potier@libertysurf.fr). 
*                                       Free for non commercial use (please let author's name)
/******************************************************************************************************************/
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace EventReminder
{
	/// <summary>
	/// Description rsume de FormMain.
	/// </summary>
	public class FormMain : System.Windows.Forms.Form
	{

		/// <summary>
		/// Variable ncessaire au concepteur.
		/// </summary>
		public static FormMain current_form_main;
		public class_main the_main;

		public UtilityLibrary.WinControls.ListViewEx listView_event;
		public UtilityLibrary.WinControls.OutlookBar outlookbar;

		public System.Windows.Forms.ImageList imageList_icons;
		public System.Windows.Forms.ImageList imageList_big_icones;
		public System.Windows.Forms.Panel panel_listview;
		public System.Windows.Forms.Panel panel_outlookbar;
		public System.Windows.Forms.MonthCalendar monthCalendar;
		public System.Windows.Forms.ListBox listBox_welcome_messages;
		public System.Windows.Forms.CheckBox checkBox_message_if_no_event;
		public System.Windows.Forms.CheckBox checkBox_welcome_message_at_startup;
		public System.Windows.Forms.TextBox textBox_speech_n_days_before;
		public System.Windows.Forms.TextBox textBox_no_event_in_the_following_days;
		public System.Windows.Forms.ImageList imageList_menu;

		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Button button_add;
		private System.Windows.Forms.Button button_edit_selected;
		private System.Windows.Forms.Button button_remove_selected;
		private System.Windows.Forms.Label label_speech_remaining_days;
		private System.Windows.Forms.Panel panel_voice_option;
		private System.Windows.Forms.Panel panel_msg;
		private System.Windows.Forms.Panel panel_list_view_with_msg;
		private System.Windows.Forms.Panel panel_welcome_messages;
		private System.Windows.Forms.Button button_cancel;
		private System.Windows.Forms.Button button_ok;
		private System.Windows.Forms.RadioButton radioButton_following_options;
        private System.Windows.Forms.RadioButton radioButton_default_voice_option;
		private System.Windows.Forms.ComboBox comboBox_ttsengine;
		private System.Windows.Forms.ComboBox comboBox_language;
        private System.Windows.Forms.Label label_select_language_or_tts;
		private System.Windows.Forms.GroupBox groupBox_user_voice_option;
		private System.Windows.Forms.ComboBox comboBox_context_output_text;
		private System.Windows.Forms.ComboBox comboBox_character_voice;
		private System.Windows.Forms.Label label_voice_context;
		private System.Windows.Forms.Label label_voice_char;
		private System.Windows.Forms.Label label_pitch;
		private System.Windows.Forms.Label label_speed;
		private System.Windows.Forms.TrackBar trackBar_speed;
		private System.Windows.Forms.TrackBar trackBar_pitch;
		private System.Windows.Forms.TextBox textBox_voice_test;
		private System.Windows.Forms.Button button_test;
		private System.Windows.Forms.Label label_read_text_test;
		private System.Windows.Forms.OpenFileDialog openFileDialog;
		private System.Windows.Forms.Button button_remove_selected_message;
		private System.Windows.Forms.Button button_add_messages;
		private System.Windows.Forms.TextBox textBox_welcome_message;
		private System.Windows.Forms.Label label_add_welcome_message;
		private System.Windows.Forms.Panel panel_Voice_Help;
		private System.Windows.Forms.Panel panel_About;
		private System.Windows.Forms.LinkLabel linkLabel_mail;
		private System.Windows.Forms.TextBox textBox_about_text;
		private System.Windows.Forms.TextBox textBox_Voice_Help;
		private System.Windows.Forms.PictureBox pictureBox1;
        private System.Windows.Forms.Label label;
		private System.Windows.Forms.Button Button_listview_with_msg_apply;
        private CheckBox checkBox_ballon;
        private Button button_browse_agent_name;
        private Label label_agent_name;
        private TextBox textBox_agent_name;
        private Button button_startup_option_apply;
        private GroupBox groupBox_startup_option_start;
        private TextBox textBox_startup_options_min;
        private TextBox textBox_startup_options_hour;
        private TextBox textBox_startup_options_days_interval;
        private RadioButton radioButton_run_with_windows_task;
        private GroupBox groupBox1;
        private GroupBox groupBox2;
        private Label label1;
        private GroupBox groupBoxSapi4;
        private ComboBox comboBox_sapi5_voices;
        private Label labelSAPI5Voices;
        private Label labelSAPI4Voices;
        private Label labelLanguage;
        private Label labelSapiWin8Plusinfos;
        private RadioButton radioButton_run_at_startup;
		
		

		public FormMain()
		{
			
			//
			// Requis pour la prise en charge du Concepteur Windows Forms
			//
			InitializeComponent();
			//
			// TODO : ajoutez le code du constructeur aprs l'appel  InitializeComponent
			//
			this.Height=470;// should be put here if we want startup position centerscreen works (edition size !=running size)
		}

		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(FormMain));
            this.monthCalendar = new System.Windows.Forms.MonthCalendar();
            this.panel_outlookbar = new System.Windows.Forms.Panel();
            this.panel_list_view_with_msg = new System.Windows.Forms.Panel();
            this.Button_listview_with_msg_apply = new System.Windows.Forms.Button();
            this.textBox_speech_n_days_before = new System.Windows.Forms.TextBox();
            this.label_speech_remaining_days = new System.Windows.Forms.Label();
            this.textBox_no_event_in_the_following_days = new System.Windows.Forms.TextBox();
            this.checkBox_message_if_no_event = new System.Windows.Forms.CheckBox();
            this.panel_msg = new System.Windows.Forms.Panel();
            this.button_remove_selected = new System.Windows.Forms.Button();
            this.button_edit_selected = new System.Windows.Forms.Button();
            this.button_add = new System.Windows.Forms.Button();
            this.panel_listview = new System.Windows.Forms.Panel();
            this.imageList_icons = new System.Windows.Forms.ImageList(this.components);
            this.imageList_big_icones = new System.Windows.Forms.ImageList(this.components);
            this.panel_voice_option = new System.Windows.Forms.Panel();
            this.labelSapiWin8Plusinfos = new System.Windows.Forms.Label();
            this.groupBoxSapi4 = new System.Windows.Forms.GroupBox();
            this.radioButton_following_options = new System.Windows.Forms.RadioButton();
            this.radioButton_default_voice_option = new System.Windows.Forms.RadioButton();
            this.groupBox_user_voice_option = new System.Windows.Forms.GroupBox();
            this.comboBox_context_output_text = new System.Windows.Forms.ComboBox();
            this.comboBox_character_voice = new System.Windows.Forms.ComboBox();
            this.label_voice_context = new System.Windows.Forms.Label();
            this.label_voice_char = new System.Windows.Forms.Label();
            this.label_pitch = new System.Windows.Forms.Label();
            this.label_speed = new System.Windows.Forms.Label();
            this.trackBar_speed = new System.Windows.Forms.TrackBar();
            this.trackBar_pitch = new System.Windows.Forms.TrackBar();
            this.comboBox_sapi5_voices = new System.Windows.Forms.ComboBox();
            this.labelSAPI5Voices = new System.Windows.Forms.Label();
            this.labelSAPI4Voices = new System.Windows.Forms.Label();
            this.labelLanguage = new System.Windows.Forms.Label();
            this.textBox_voice_test = new System.Windows.Forms.TextBox();
            this.label_read_text_test = new System.Windows.Forms.Label();
            this.button_test = new System.Windows.Forms.Button();
            this.button_cancel = new System.Windows.Forms.Button();
            this.button_ok = new System.Windows.Forms.Button();
            this.comboBox_ttsengine = new System.Windows.Forms.ComboBox();
            this.comboBox_language = new System.Windows.Forms.ComboBox();
            this.label_select_language_or_tts = new System.Windows.Forms.Label();
            this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
            this.panel_welcome_messages = new System.Windows.Forms.Panel();
            this.button_startup_option_apply = new System.Windows.Forms.Button();
            this.button_browse_agent_name = new System.Windows.Forms.Button();
            this.textBox_agent_name = new System.Windows.Forms.TextBox();
            this.groupBox_startup_option_start = new System.Windows.Forms.GroupBox();
            this.textBox_startup_options_min = new System.Windows.Forms.TextBox();
            this.textBox_startup_options_hour = new System.Windows.Forms.TextBox();
            this.textBox_startup_options_days_interval = new System.Windows.Forms.TextBox();
            this.radioButton_run_with_windows_task = new System.Windows.Forms.RadioButton();
            this.radioButton_run_at_startup = new System.Windows.Forms.RadioButton();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.checkBox_ballon = new System.Windows.Forms.CheckBox();
            this.label_agent_name = new System.Windows.Forms.Label();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.label1 = new System.Windows.Forms.Label();
            this.checkBox_welcome_message_at_startup = new System.Windows.Forms.CheckBox();
            this.listBox_welcome_messages = new System.Windows.Forms.ListBox();
            this.button_remove_selected_message = new System.Windows.Forms.Button();
            this.button_add_messages = new System.Windows.Forms.Button();
            this.textBox_welcome_message = new System.Windows.Forms.TextBox();
            this.label_add_welcome_message = new System.Windows.Forms.Label();
            this.imageList_menu = new System.Windows.Forms.ImageList(this.components);
            this.panel_Voice_Help = new System.Windows.Forms.Panel();
            this.textBox_Voice_Help = new System.Windows.Forms.TextBox();
            this.panel_About = new System.Windows.Forms.Panel();
            this.label = new System.Windows.Forms.Label();
            this.pictureBox1 = new System.Windows.Forms.PictureBox();
            this.textBox_about_text = new System.Windows.Forms.TextBox();
            this.linkLabel_mail = new System.Windows.Forms.LinkLabel();
            this.panel_list_view_with_msg.SuspendLayout();
            this.panel_msg.SuspendLayout();
            this.panel_voice_option.SuspendLayout();
            this.groupBoxSapi4.SuspendLayout();
            this.groupBox_user_voice_option.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.trackBar_speed)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.trackBar_pitch)).BeginInit();
            this.panel_welcome_messages.SuspendLayout();
            this.groupBox_startup_option_start.SuspendLayout();
            this.groupBox1.SuspendLayout();
            this.groupBox2.SuspendLayout();
            this.panel_Voice_Help.SuspendLayout();
            this.panel_About.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).BeginInit();
            this.SuspendLayout();
            // 
            // monthCalendar
            // 
            this.monthCalendar.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.monthCalendar.Location = new System.Drawing.Point(102, 0);
            this.monthCalendar.Margin = new System.Windows.Forms.Padding(0);
            this.monthCalendar.MaxSelectionCount = 1;
            this.monthCalendar.Name = "monthCalendar";
            this.monthCalendar.TabIndex = 0;
            this.monthCalendar.DateSelected += new System.Windows.Forms.DateRangeEventHandler(this.monthCalendar_DateSelected);
            // 
            // panel_outlookbar
            // 
            this.panel_outlookbar.Location = new System.Drawing.Point(0, -2);
            this.panel_outlookbar.Name = "panel_outlookbar";
            this.panel_outlookbar.Size = new System.Drawing.Size(100, 442);
            this.panel_outlookbar.TabIndex = 1;
            // 
            // panel_list_view_with_msg
            // 
            this.panel_list_view_with_msg.Controls.Add(this.Button_listview_with_msg_apply);
            this.panel_list_view_with_msg.Controls.Add(this.textBox_speech_n_days_before);
            this.panel_list_view_with_msg.Controls.Add(this.label_speech_remaining_days);
            this.panel_list_view_with_msg.Controls.Add(this.textBox_no_event_in_the_following_days);
            this.panel_list_view_with_msg.Controls.Add(this.checkBox_message_if_no_event);
            this.panel_list_view_with_msg.Controls.Add(this.panel_msg);
            this.panel_list_view_with_msg.Controls.Add(this.panel_listview);
            this.panel_list_view_with_msg.Location = new System.Drawing.Point(100, 0);
            this.panel_list_view_with_msg.Name = "panel_list_view_with_msg";
            this.panel_list_view_with_msg.Size = new System.Drawing.Size(808, 440);
            this.panel_list_view_with_msg.TabIndex = 3;
            // 
            // Button_listview_with_msg_apply
            // 
            this.Button_listview_with_msg_apply.Location = new System.Drawing.Point(568, 392);
            this.Button_listview_with_msg_apply.Name = "Button_listview_with_msg_apply";
            this.Button_listview_with_msg_apply.Size = new System.Drawing.Size(75, 23);
            this.Button_listview_with_msg_apply.TabIndex = 6;
            this.Button_listview_with_msg_apply.Text = "Apply";
            this.Button_listview_with_msg_apply.Click += new System.EventHandler(this.Button_listview_with_msg_apply_Click);
            // 
            // textBox_speech_n_days_before
            // 
            this.textBox_speech_n_days_before.Location = new System.Drawing.Point(336, 360);
            this.textBox_speech_n_days_before.Name = "textBox_speech_n_days_before";
            this.textBox_speech_n_days_before.Size = new System.Drawing.Size(256, 20);
            this.textBox_speech_n_days_before.TabIndex = 3;
            this.textBox_speech_n_days_before.Text = "_n_days days before _event";
            // 
            // label_speech_remaining_days
            // 
            this.label_speech_remaining_days.Location = new System.Drawing.Point(16, 360);
            this.label_speech_remaining_days.Name = "label_speech_remaining_days";
            this.label_speech_remaining_days.Size = new System.Drawing.Size(320, 24);
            this.label_speech_remaining_days.TabIndex = 4;
            this.label_speech_remaining_days.Text = "If it reminds n days (_n_days) before an event (_event) say :";
            // 
            // textBox_no_event_in_the_following_days
            // 
            this.textBox_no_event_in_the_following_days.Location = new System.Drawing.Point(336, 392);
            this.textBox_no_event_in_the_following_days.Name = "textBox_no_event_in_the_following_days";
            this.textBox_no_event_in_the_following_days.Size = new System.Drawing.Size(200, 20);
            this.textBox_no_event_in_the_following_days.TabIndex = 5;
            this.textBox_no_event_in_the_following_days.Text = "No events in the following days...";
            // 
            // checkBox_message_if_no_event
            // 
            this.checkBox_message_if_no_event.Location = new System.Drawing.Point(16, 392);
            this.checkBox_message_if_no_event.Name = "checkBox_message_if_no_event";
            this.checkBox_message_if_no_event.Size = new System.Drawing.Size(320, 24);
            this.checkBox_message_if_no_event.TabIndex = 4;
            this.checkBox_message_if_no_event.Text = "Speak if no event in the following days.               Speech :";
            // 
            // panel_msg
            // 
            this.panel_msg.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Right)));
            this.panel_msg.Controls.Add(this.button_remove_selected);
            this.panel_msg.Controls.Add(this.button_edit_selected);
            this.panel_msg.Controls.Add(this.button_add);
            this.panel_msg.Location = new System.Drawing.Point(680, 0);
            this.panel_msg.Name = "panel_msg";
            this.panel_msg.Size = new System.Drawing.Size(128, 440);
            this.panel_msg.TabIndex = 0;
            // 
            // button_remove_selected
            // 
            this.button_remove_selected.Location = new System.Drawing.Point(16, 128);
            this.button_remove_selected.Name = "button_remove_selected";
            this.button_remove_selected.Size = new System.Drawing.Size(96, 24);
            this.button_remove_selected.TabIndex = 2;
            this.button_remove_selected.Text = "Remove";
            this.button_remove_selected.Click += new System.EventHandler(this.button_remove_selected_Click);
            // 
            // button_edit_selected
            // 
            this.button_edit_selected.Location = new System.Drawing.Point(16, 88);
            this.button_edit_selected.Name = "button_edit_selected";
            this.button_edit_selected.Size = new System.Drawing.Size(96, 24);
            this.button_edit_selected.TabIndex = 1;
            this.button_edit_selected.Text = "Edit";
            this.button_edit_selected.Click += new System.EventHandler(this.button_edit_selected_Click);
            // 
            // button_add
            // 
            this.button_add.Location = new System.Drawing.Point(16, 48);
            this.button_add.Name = "button_add";
            this.button_add.Size = new System.Drawing.Size(96, 24);
            this.button_add.TabIndex = 0;
            this.button_add.Text = "Add";
            this.button_add.Click += new System.EventHandler(this.button_add_Click);
            // 
            // panel_listview
            // 
            this.panel_listview.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left)));
            this.panel_listview.Location = new System.Drawing.Point(0, 0);
            this.panel_listview.Name = "panel_listview";
            this.panel_listview.Size = new System.Drawing.Size(680, 344);
            this.panel_listview.TabIndex = 0;
            // 
            // imageList_icons
            // 
            this.imageList_icons.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList_icons.ImageStream")));
            this.imageList_icons.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList_icons.Images.SetKeyName(0, "");
            this.imageList_icons.Images.SetKeyName(1, "");
            this.imageList_icons.Images.SetKeyName(2, "");
            // 
            // imageList_big_icones
            // 
            this.imageList_big_icones.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList_big_icones.ImageStream")));
            this.imageList_big_icones.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList_big_icones.Images.SetKeyName(0, "");
            this.imageList_big_icones.Images.SetKeyName(1, "");
            this.imageList_big_icones.Images.SetKeyName(2, "");
            this.imageList_big_icones.Images.SetKeyName(3, "");
            this.imageList_big_icones.Images.SetKeyName(4, "");
            this.imageList_big_icones.Images.SetKeyName(5, "");
            // 
            // panel_voice_option
            // 
            this.panel_voice_option.Controls.Add(this.labelSapiWin8Plusinfos);
            this.panel_voice_option.Controls.Add(this.groupBoxSapi4);
            this.panel_voice_option.Controls.Add(this.comboBox_sapi5_voices);
            this.panel_voice_option.Controls.Add(this.labelSAPI5Voices);
            this.panel_voice_option.Controls.Add(this.labelSAPI4Voices);
            this.panel_voice_option.Controls.Add(this.labelLanguage);
            this.panel_voice_option.Controls.Add(this.textBox_voice_test);
            this.panel_voice_option.Controls.Add(this.label_read_text_test);
            this.panel_voice_option.Controls.Add(this.button_test);
            this.panel_voice_option.Controls.Add(this.button_cancel);
            this.panel_voice_option.Controls.Add(this.button_ok);
            this.panel_voice_option.Controls.Add(this.comboBox_ttsengine);
            this.panel_voice_option.Controls.Add(this.comboBox_language);
            this.panel_voice_option.Controls.Add(this.label_select_language_or_tts);
            this.panel_voice_option.Location = new System.Drawing.Point(88, 448);
            this.panel_voice_option.Name = "panel_voice_option";
            this.panel_voice_option.Size = new System.Drawing.Size(808, 440);
            this.panel_voice_option.TabIndex = 4;
            // 
            // labelSapiWin8Plusinfos
            // 
            this.labelSapiWin8Plusinfos.Location = new System.Drawing.Point(28, 182);
            this.labelSapiWin8Plusinfos.Name = "labelSapiWin8Plusinfos";
            this.labelSapiWin8Plusinfos.Size = new System.Drawing.Size(372, 39);
            this.labelSapiWin8Plusinfos.TabIndex = 34;
            this.labelSapiWin8Plusinfos.Text = "For Windows 8 and higher, voice and language selection are available only from co" +
    "ntrol panel under speech or text-to-speech settings";
            this.labelSapiWin8Plusinfos.Visible = false;
            // 
            // groupBoxSapi4
            // 
            this.groupBoxSapi4.Controls.Add(this.radioButton_following_options);
            this.groupBoxSapi4.Controls.Add(this.radioButton_default_voice_option);
            this.groupBoxSapi4.Controls.Add(this.groupBox_user_voice_option);
            this.groupBoxSapi4.Location = new System.Drawing.Point(425, 17);
            this.groupBoxSapi4.Name = "groupBoxSapi4";
            this.groupBoxSapi4.Size = new System.Drawing.Size(369, 302);
            this.groupBoxSapi4.TabIndex = 33;
            this.groupBoxSapi4.TabStop = false;
            this.groupBoxSapi4.Text = "SAPI 4 voice options";
            // 
            // radioButton_following_options
            // 
            this.radioButton_following_options.Location = new System.Drawing.Point(15, 37);
            this.radioButton_following_options.Name = "radioButton_following_options";
            this.radioButton_following_options.Size = new System.Drawing.Size(208, 16);
            this.radioButton_following_options.TabIndex = 22;
            this.radioButton_following_options.Text = "Use following options";
            this.radioButton_following_options.CheckedChanged += new System.EventHandler(this.radioButton_following_options_Checked_Changed);
            // 
            // radioButton_default_voice_option
            // 
            this.radioButton_default_voice_option.Checked = true;
            this.radioButton_default_voice_option.Location = new System.Drawing.Point(15, 13);
            this.radioButton_default_voice_option.Name = "radioButton_default_voice_option";
            this.radioButton_default_voice_option.Size = new System.Drawing.Size(208, 24);
            this.radioButton_default_voice_option.TabIndex = 21;
            this.radioButton_default_voice_option.TabStop = true;
            this.radioButton_default_voice_option.Text = "Use default voice options";
            // 
            // groupBox_user_voice_option
            // 
            this.groupBox_user_voice_option.Controls.Add(this.comboBox_context_output_text);
            this.groupBox_user_voice_option.Controls.Add(this.comboBox_character_voice);
            this.groupBox_user_voice_option.Controls.Add(this.label_voice_context);
            this.groupBox_user_voice_option.Controls.Add(this.label_voice_char);
            this.groupBox_user_voice_option.Controls.Add(this.label_pitch);
            this.groupBox_user_voice_option.Controls.Add(this.label_speed);
            this.groupBox_user_voice_option.Controls.Add(this.trackBar_speed);
            this.groupBox_user_voice_option.Controls.Add(this.trackBar_pitch);
            this.groupBox_user_voice_option.Enabled = false;
            this.groupBox_user_voice_option.Location = new System.Drawing.Point(15, 45);
            this.groupBox_user_voice_option.Name = "groupBox_user_voice_option";
            this.groupBox_user_voice_option.Size = new System.Drawing.Size(344, 248);
            this.groupBox_user_voice_option.TabIndex = 23;
            this.groupBox_user_voice_option.TabStop = false;
            // 
            // comboBox_context_output_text
            // 
            this.comboBox_context_output_text.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBox_context_output_text.Location = new System.Drawing.Point(64, 208);
            this.comboBox_context_output_text.Name = "comboBox_context_output_text";
            this.comboBox_context_output_text.Size = new System.Drawing.Size(200, 21);
            this.comboBox_context_output_text.TabIndex = 22;
            this.comboBox_context_output_text.SelectedIndexChanged += new System.EventHandler(this.comboBox_context_output_text_SelectedIndexChanged);
            // 
            // comboBox_character_voice
            // 
            this.comboBox_character_voice.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBox_character_voice.Location = new System.Drawing.Point(64, 150);
            this.comboBox_character_voice.Name = "comboBox_character_voice";
            this.comboBox_character_voice.Size = new System.Drawing.Size(200, 21);
            this.comboBox_character_voice.TabIndex = 21;
            this.comboBox_character_voice.SelectedIndexChanged += new System.EventHandler(this.comboBox_character_voice_SelectedIndexChanged);
            // 
            // label_voice_context
            // 
            this.label_voice_context.BackColor = System.Drawing.SystemColors.Control;
            this.label_voice_context.Cursor = System.Windows.Forms.Cursors.Default;
            this.label_voice_context.ForeColor = System.Drawing.SystemColors.ControlText;
            this.label_voice_context.Location = new System.Drawing.Point(24, 187);
            this.label_voice_context.Name = "label_voice_context";
            this.label_voice_context.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.label_voice_context.Size = new System.Drawing.Size(232, 17);
            this.label_voice_context.TabIndex = 18;
            this.label_voice_context.Text = "Context of the output text";
            // 
            // label_voice_char
            // 
            this.label_voice_char.BackColor = System.Drawing.SystemColors.Control;
            this.label_voice_char.Cursor = System.Windows.Forms.Cursors.Default;
            this.label_voice_char.ForeColor = System.Drawing.SystemColors.ControlText;
            this.label_voice_char.Location = new System.Drawing.Point(24, 120);
            this.label_voice_char.Name = "label_voice_char";
            this.label_voice_char.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.label_voice_char.Size = new System.Drawing.Size(232, 17);
            this.label_voice_char.TabIndex = 17;
            this.label_voice_char.Text = "Character of the voice";
            // 
            // label_pitch
            // 
            this.label_pitch.Location = new System.Drawing.Point(16, 72);
            this.label_pitch.Name = "label_pitch";
            this.label_pitch.Size = new System.Drawing.Size(224, 16);
            this.label_pitch.TabIndex = 1;
            this.label_pitch.Text = "Pitch (in hertz)";
            // 
            // label_speed
            // 
            this.label_speed.Location = new System.Drawing.Point(24, 19);
            this.label_speed.Name = "label_speed";
            this.label_speed.Size = new System.Drawing.Size(144, 16);
            this.label_speed.TabIndex = 0;
            this.label_speed.Text = "Speed (in word per minute)";
            // 
            // trackBar_speed
            // 
            this.trackBar_speed.AutoSize = false;
            this.trackBar_speed.LargeChange = 50;
            this.trackBar_speed.Location = new System.Drawing.Point(24, 43);
            this.trackBar_speed.Maximum = 250;
            this.trackBar_speed.Minimum = 50;
            this.trackBar_speed.Name = "trackBar_speed";
            this.trackBar_speed.Size = new System.Drawing.Size(296, 45);
            this.trackBar_speed.SmallChange = 10;
            this.trackBar_speed.TabIndex = 19;
            this.trackBar_speed.TickFrequency = 20;
            this.trackBar_speed.Value = 100;
            this.trackBar_speed.Scroll += new System.EventHandler(this.trackBar_speed_Scroll);
            // 
            // trackBar_pitch
            // 
            this.trackBar_pitch.AutoSize = false;
            this.trackBar_pitch.LargeChange = 50;
            this.trackBar_pitch.Location = new System.Drawing.Point(24, 91);
            this.trackBar_pitch.Maximum = 250;
            this.trackBar_pitch.Minimum = 50;
            this.trackBar_pitch.Name = "trackBar_pitch";
            this.trackBar_pitch.Size = new System.Drawing.Size(296, 45);
            this.trackBar_pitch.SmallChange = 10;
            this.trackBar_pitch.TabIndex = 20;
            this.trackBar_pitch.TickFrequency = 20;
            this.trackBar_pitch.Value = 100;
            this.trackBar_pitch.Scroll += new System.EventHandler(this.trackBar_pitch_Scroll);
            // 
            // comboBox_sapi5_voices
            // 
            this.comboBox_sapi5_voices.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBox_sapi5_voices.FormattingEnabled = true;
            this.comboBox_sapi5_voices.Location = new System.Drawing.Point(98, 121);
            this.comboBox_sapi5_voices.Name = "comboBox_sapi5_voices";
            this.comboBox_sapi5_voices.Size = new System.Drawing.Size(320, 21);
            this.comboBox_sapi5_voices.TabIndex = 32;
            this.comboBox_sapi5_voices.SelectedIndexChanged += new System.EventHandler(this.comboBox_sapi5_voices_SelectedIndexChanged);
            // 
            // labelSAPI5Voices
            // 
            this.labelSAPI5Voices.AutoSize = true;
            this.labelSAPI5Voices.Location = new System.Drawing.Point(16, 125);
            this.labelSAPI5Voices.Name = "labelSAPI5Voices";
            this.labelSAPI5Voices.Size = new System.Drawing.Size(75, 13);
            this.labelSAPI5Voices.TabIndex = 31;
            this.labelSAPI5Voices.Text = "SAPI 5 Voices";
            // 
            // labelSAPI4Voices
            // 
            this.labelSAPI4Voices.AutoSize = true;
            this.labelSAPI4Voices.Location = new System.Drawing.Point(16, 91);
            this.labelSAPI4Voices.Name = "labelSAPI4Voices";
            this.labelSAPI4Voices.Size = new System.Drawing.Size(75, 13);
            this.labelSAPI4Voices.TabIndex = 30;
            this.labelSAPI4Voices.Text = "SAPI 4 Voices";
            // 
            // labelLanguage
            // 
            this.labelLanguage.AutoSize = true;
            this.labelLanguage.Location = new System.Drawing.Point(16, 59);
            this.labelLanguage.Name = "labelLanguage";
            this.labelLanguage.Size = new System.Drawing.Size(55, 13);
            this.labelLanguage.TabIndex = 29;
            this.labelLanguage.Text = "Language";
            // 
            // textBox_voice_test
            // 
            this.textBox_voice_test.Location = new System.Drawing.Point(160, 328);
            this.textBox_voice_test.Name = "textBox_voice_test";
            this.textBox_voice_test.Size = new System.Drawing.Size(240, 20);
            this.textBox_voice_test.TabIndex = 24;
            this.textBox_voice_test.Text = "This is a test";
            // 
            // label_read_text_test
            // 
            this.label_read_text_test.Location = new System.Drawing.Point(16, 328);
            this.label_read_text_test.Name = "label_read_text_test";
            this.label_read_text_test.Size = new System.Drawing.Size(144, 16);
            this.label_read_text_test.TabIndex = 28;
            this.label_read_text_test.Text = "Enter a text to read :";
            // 
            // button_test
            // 
            this.button_test.Location = new System.Drawing.Point(408, 328);
            this.button_test.Name = "button_test";
            this.button_test.Size = new System.Drawing.Size(96, 24);
            this.button_test.TabIndex = 25;
            this.button_test.Text = "Test";
            this.button_test.Click += new System.EventHandler(this.button_test_Click);
            // 
            // button_cancel
            // 
            this.button_cancel.Location = new System.Drawing.Point(408, 392);
            this.button_cancel.Name = "button_cancel";
            this.button_cancel.Size = new System.Drawing.Size(96, 24);
            this.button_cancel.TabIndex = 27;
            this.button_cancel.Text = "Restore";
            this.button_cancel.Click += new System.EventHandler(this.button_cancel_Click);
            // 
            // button_ok
            // 
            this.button_ok.Location = new System.Drawing.Point(280, 392);
            this.button_ok.Name = "button_ok";
            this.button_ok.Size = new System.Drawing.Size(96, 24);
            this.button_ok.TabIndex = 26;
            this.button_ok.Text = "Apply";
            this.button_ok.Click += new System.EventHandler(this.button_ok_Click);
            // 
            // comboBox_ttsengine
            // 
            this.comboBox_ttsengine.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBox_ttsengine.Location = new System.Drawing.Point(98, 89);
            this.comboBox_ttsengine.Name = "comboBox_ttsengine";
            this.comboBox_ttsengine.Size = new System.Drawing.Size(320, 21);
            this.comboBox_ttsengine.TabIndex = 19;
            this.comboBox_ttsengine.SelectedIndexChanged += new System.EventHandler(this.comboBox_ttsengine_SelectedIndexChanged);
            // 
            // comboBox_language
            // 
            this.comboBox_language.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.comboBox_language.Location = new System.Drawing.Point(98, 57);
            this.comboBox_language.Name = "comboBox_language";
            this.comboBox_language.Size = new System.Drawing.Size(248, 21);
            this.comboBox_language.TabIndex = 18;
            this.comboBox_language.SelectedIndexChanged += new System.EventHandler(this.comboBox_language_SelectedIndexChanged);
            // 
            // label_select_language_or_tts
            // 
            this.label_select_language_or_tts.Location = new System.Drawing.Point(25, 32);
            this.label_select_language_or_tts.Name = "label_select_language_or_tts";
            this.label_select_language_or_tts.Size = new System.Drawing.Size(184, 16);
            this.label_select_language_or_tts.TabIndex = 17;
            this.label_select_language_or_tts.Text = "Choose a language or a voice";
            // 
            // openFileDialog
            // 
            this.openFileDialog.Filter = "Agents files (*.acs)|*.acs";
            // 
            // panel_welcome_messages
            // 
            this.panel_welcome_messages.Controls.Add(this.button_startup_option_apply);
            this.panel_welcome_messages.Controls.Add(this.button_browse_agent_name);
            this.panel_welcome_messages.Controls.Add(this.textBox_agent_name);
            this.panel_welcome_messages.Controls.Add(this.groupBox_startup_option_start);
            this.panel_welcome_messages.Controls.Add(this.groupBox1);
            this.panel_welcome_messages.Controls.Add(this.groupBox2);
            this.panel_welcome_messages.Location = new System.Drawing.Point(64, 496);
            this.panel_welcome_messages.Name = "panel_welcome_messages";
            this.panel_welcome_messages.Size = new System.Drawing.Size(808, 440);
            this.panel_welcome_messages.TabIndex = 5;
            // 
            // button_startup_option_apply
            // 
            this.button_startup_option_apply.Location = new System.Drawing.Point(706, 399);
            this.button_startup_option_apply.Name = "button_startup_option_apply";
            this.button_startup_option_apply.Size = new System.Drawing.Size(75, 23);
            this.button_startup_option_apply.TabIndex = 18;
            this.button_startup_option_apply.Text = "Apply";
            this.button_startup_option_apply.Click += new System.EventHandler(this.button_startup_option_apply_Click);
            // 
            // button_browse_agent_name
            // 
            this.button_browse_agent_name.Location = new System.Drawing.Point(701, 59);
            this.button_browse_agent_name.Name = "button_browse_agent_name";
            this.button_browse_agent_name.Size = new System.Drawing.Size(80, 24);
            this.button_browse_agent_name.TabIndex = 23;
            this.button_browse_agent_name.Text = "Browse";
            this.button_browse_agent_name.Click += new System.EventHandler(this.button_browse_agent_name_Click);
            // 
            // textBox_agent_name
            // 
            this.textBox_agent_name.Location = new System.Drawing.Point(362, 62);
            this.textBox_agent_name.Name = "textBox_agent_name";
            this.textBox_agent_name.Size = new System.Drawing.Size(317, 20);
            this.textBox_agent_name.TabIndex = 21;
            // 
            // groupBox_startup_option_start
            // 
            this.groupBox_startup_option_start.Controls.Add(this.textBox_startup_options_min);
            this.groupBox_startup_option_start.Controls.Add(this.textBox_startup_options_hour);
            this.groupBox_startup_option_start.Controls.Add(this.textBox_startup_options_days_interval);
            this.groupBox_startup_option_start.Controls.Add(this.radioButton_run_with_windows_task);
            this.groupBox_startup_option_start.Controls.Add(this.radioButton_run_at_startup);
            this.groupBox_startup_option_start.Location = new System.Drawing.Point(10, 13);
            this.groupBox_startup_option_start.Name = "groupBox_startup_option_start";
            this.groupBox_startup_option_start.Size = new System.Drawing.Size(308, 117);
            this.groupBox_startup_option_start.TabIndex = 13;
            this.groupBox_startup_option_start.TabStop = false;
            this.groupBox_startup_option_start.Text = "Startup";
            // 
            // textBox_startup_options_min
            // 
            this.textBox_startup_options_min.Location = new System.Drawing.Point(232, 64);
            this.textBox_startup_options_min.Name = "textBox_startup_options_min";
            this.textBox_startup_options_min.Size = new System.Drawing.Size(24, 20);
            this.textBox_startup_options_min.TabIndex = 17;
            this.textBox_startup_options_min.Text = "00";
            this.textBox_startup_options_min.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
            // 
            // textBox_startup_options_hour
            // 
            this.textBox_startup_options_hour.Location = new System.Drawing.Point(200, 64);
            this.textBox_startup_options_hour.Name = "textBox_startup_options_hour";
            this.textBox_startup_options_hour.Size = new System.Drawing.Size(24, 20);
            this.textBox_startup_options_hour.TabIndex = 16;
            this.textBox_startup_options_hour.Text = "14";
            this.textBox_startup_options_hour.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
            // 
            // textBox_startup_options_days_interval
            // 
            this.textBox_startup_options_days_interval.Location = new System.Drawing.Point(104, 64);
            this.textBox_startup_options_days_interval.Name = "textBox_startup_options_days_interval";
            this.textBox_startup_options_days_interval.Size = new System.Drawing.Size(32, 20);
            this.textBox_startup_options_days_interval.TabIndex = 15;
            this.textBox_startup_options_days_interval.Text = "3";
            this.textBox_startup_options_days_interval.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
            // 
            // radioButton_run_with_windows_task
            // 
            this.radioButton_run_with_windows_task.Location = new System.Drawing.Point(16, 64);
            this.radioButton_run_with_windows_task.Name = "radioButton_run_with_windows_task";
            this.radioButton_run_with_windows_task.Size = new System.Drawing.Size(184, 24);
            this.radioButton_run_with_windows_task.TabIndex = 14;
            this.radioButton_run_with_windows_task.Text = "Run every                    days at :";
            // 
            // radioButton_run_at_startup
            // 
            this.radioButton_run_at_startup.Checked = true;
            this.radioButton_run_at_startup.Location = new System.Drawing.Point(16, 24);
            this.radioButton_run_at_startup.Name = "radioButton_run_at_startup";
            this.radioButton_run_at_startup.Size = new System.Drawing.Size(128, 24);
            this.radioButton_run_at_startup.TabIndex = 13;
            this.radioButton_run_at_startup.TabStop = true;
            this.radioButton_run_at_startup.Text = "Run at startup";
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.checkBox_ballon);
            this.groupBox1.Controls.Add(this.label_agent_name);
            this.groupBox1.Location = new System.Drawing.Point(332, 13);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(460, 117);
            this.groupBox1.TabIndex = 25;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "Agent";
            // 
            // checkBox_ballon
            // 
            this.checkBox_ballon.Location = new System.Drawing.Point(9, 75);
            this.checkBox_ballon.Name = "checkBox_ballon";
            this.checkBox_ballon.Size = new System.Drawing.Size(221, 26);
            this.checkBox_ballon.TabIndex = 24;
            this.checkBox_ballon.Text = "Display spoken text in balloon";
            this.checkBox_ballon.CheckedChanged += new System.EventHandler(this.checkBox_ballon_checked_changed);
            // 
            // label_agent_name
            // 
            this.label_agent_name.Location = new System.Drawing.Point(6, 20);
            this.label_agent_name.Name = "label_agent_name";
            this.label_agent_name.Size = new System.Drawing.Size(152, 16);
            this.label_agent_name.TabIndex = 22;
            this.label_agent_name.Text = "Agent Name";
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.label1);
            this.groupBox2.Controls.Add(this.checkBox_welcome_message_at_startup);
            this.groupBox2.Controls.Add(this.listBox_welcome_messages);
            this.groupBox2.Controls.Add(this.button_remove_selected_message);
            this.groupBox2.Controls.Add(this.button_add_messages);
            this.groupBox2.Controls.Add(this.textBox_welcome_message);
            this.groupBox2.Controls.Add(this.label_add_welcome_message);
            this.groupBox2.Location = new System.Drawing.Point(10, 136);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(776, 257);
            this.groupBox2.TabIndex = 26;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "Welcome Messages";
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(419, 144);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(140, 13);
            this.label1.TabIndex = 6;
            this.label1.Text = "Remove selected messages";
            // 
            // checkBox_welcome_message_at_startup
            // 
            this.checkBox_welcome_message_at_startup.Checked = true;
            this.checkBox_welcome_message_at_startup.CheckState = System.Windows.Forms.CheckState.Checked;
            this.checkBox_welcome_message_at_startup.Location = new System.Drawing.Point(16, 25);
            this.checkBox_welcome_message_at_startup.Name = "checkBox_welcome_message_at_startup";
            this.checkBox_welcome_message_at_startup.Size = new System.Drawing.Size(240, 24);
            this.checkBox_welcome_message_at_startup.TabIndex = 5;
            this.checkBox_welcome_message_at_startup.Text = "Read a random message at startup";
            this.checkBox_welcome_message_at_startup.CheckedChanged += new System.EventHandler(this.checkBox_welcome_message_at_startup_CheckedChanged);
            // 
            // listBox_welcome_messages
            // 
            this.listBox_welcome_messages.Location = new System.Drawing.Point(28, 56);
            this.listBox_welcome_messages.Name = "listBox_welcome_messages";
            this.listBox_welcome_messages.SelectionMode = System.Windows.Forms.SelectionMode.MultiExtended;
            this.listBox_welcome_messages.Size = new System.Drawing.Size(385, 186);
            this.listBox_welcome_messages.TabIndex = 0;
            // 
            // button_remove_selected_message
            // 
            this.button_remove_selected_message.Location = new System.Drawing.Point(674, 138);
            this.button_remove_selected_message.Name = "button_remove_selected_message";
            this.button_remove_selected_message.Size = new System.Drawing.Size(96, 24);
            this.button_remove_selected_message.TabIndex = 3;
            this.button_remove_selected_message.Text = "Remove";
            this.button_remove_selected_message.Click += new System.EventHandler(this.button_remove_selected_message_Click);
            // 
            // button_add_messages
            // 
            this.button_add_messages.Location = new System.Drawing.Point(674, 80);
            this.button_add_messages.Name = "button_add_messages";
            this.button_add_messages.Size = new System.Drawing.Size(96, 24);
            this.button_add_messages.TabIndex = 2;
            this.button_add_messages.Text = "Add";
            this.button_add_messages.Click += new System.EventHandler(this.button_add_messages_Click);
            // 
            // textBox_welcome_message
            // 
            this.textBox_welcome_message.Location = new System.Drawing.Point(436, 83);
            this.textBox_welcome_message.Name = "textBox_welcome_message";
            this.textBox_welcome_message.Size = new System.Drawing.Size(232, 20);
            this.textBox_welcome_message.TabIndex = 1;
            this.textBox_welcome_message.Text = "Hello, what\'s up";
            // 
            // label_add_welcome_message
            // 
            this.label_add_welcome_message.Location = new System.Drawing.Point(419, 62);
            this.label_add_welcome_message.Name = "label_add_welcome_message";
            this.label_add_welcome_message.Size = new System.Drawing.Size(184, 24);
            this.label_add_welcome_message.TabIndex = 4;
            this.label_add_welcome_message.Text = "Add a new welcome message";
            // 
            // imageList_menu
            // 
            this.imageList_menu.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList_menu.ImageStream")));
            this.imageList_menu.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList_menu.Images.SetKeyName(0, "");
            this.imageList_menu.Images.SetKeyName(1, "");
            this.imageList_menu.Images.SetKeyName(2, "");
            // 
            // panel_Voice_Help
            // 
            this.panel_Voice_Help.Controls.Add(this.textBox_Voice_Help);
            this.panel_Voice_Help.Location = new System.Drawing.Point(40, 536);
            this.panel_Voice_Help.Name = "panel_Voice_Help";
            this.panel_Voice_Help.Size = new System.Drawing.Size(808, 424);
            this.panel_Voice_Help.TabIndex = 6;
            // 
            // textBox_Voice_Help
            // 
            this.textBox_Voice_Help.BackColor = System.Drawing.SystemColors.Control;
            this.textBox_Voice_Help.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.textBox_Voice_Help.CausesValidation = false;
            this.textBox_Voice_Help.Location = new System.Drawing.Point(67, 5);
            this.textBox_Voice_Help.Multiline = true;
            this.textBox_Voice_Help.Name = "textBox_Voice_Help";
            this.textBox_Voice_Help.ReadOnly = true;
            this.textBox_Voice_Help.Size = new System.Drawing.Size(685, 410);
            this.textBox_Voice_Help.TabIndex = 0;
            this.textBox_Voice_Help.Text = "System Requirements";
            // 
            // panel_About
            // 
            this.panel_About.Controls.Add(this.label);
            this.panel_About.Controls.Add(this.pictureBox1);
            this.panel_About.Controls.Add(this.textBox_about_text);
            this.panel_About.Controls.Add(this.linkLabel_mail);
            this.panel_About.Location = new System.Drawing.Point(24, 568);
            this.panel_About.Name = "panel_About";
            this.panel_About.Size = new System.Drawing.Size(792, 408);
            this.panel_About.TabIndex = 7;
            // 
            // label
            // 
            this.label.AutoSize = true;
            this.label.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label.Location = new System.Drawing.Point(430, 194);
            this.label.Name = "label";
            this.label.Size = new System.Drawing.Size(75, 15);
            this.label.TabIndex = 4;
            this.label.Text = "Freeware By";
            this.label.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // pictureBox1
            // 
            this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
            this.pictureBox1.Location = new System.Drawing.Point(159, 116);
            this.pictureBox1.Name = "pictureBox1";
            this.pictureBox1.Size = new System.Drawing.Size(144, 176);
            this.pictureBox1.TabIndex = 3;
            this.pictureBox1.TabStop = false;
            // 
            // textBox_about_text
            // 
            this.textBox_about_text.BackColor = System.Drawing.SystemColors.Control;
            this.textBox_about_text.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.textBox_about_text.Font = new System.Drawing.Font("Microsoft Sans Serif", 14F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.textBox_about_text.Location = new System.Drawing.Point(306, 150);
            this.textBox_about_text.Multiline = true;
            this.textBox_about_text.Name = "textBox_about_text";
            this.textBox_about_text.ReadOnly = true;
            this.textBox_about_text.Size = new System.Drawing.Size(324, 36);
            this.textBox_about_text.TabIndex = 2;
            this.textBox_about_text.Text = "Speaking Event Reminder";
            this.textBox_about_text.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
            // 
            // linkLabel_mail
            // 
            this.linkLabel_mail.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.linkLabel_mail.Location = new System.Drawing.Point(310, 226);
            this.linkLabel_mail.Name = "linkLabel_mail";
            this.linkLabel_mail.Size = new System.Drawing.Size(324, 32);
            this.linkLabel_mail.TabIndex = 1;
            this.linkLabel_mail.TabStop = true;
            this.linkLabel_mail.Text = "jacquelin.potier@libertysurf.fr";
            this.linkLabel_mail.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            this.linkLabel_mail.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabel_mail_LinkClicked);
            // 
            // FormMain
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(1026, 977);
            this.Controls.Add(this.panel_voice_option);
            this.Controls.Add(this.panel_Voice_Help);
            this.Controls.Add(this.panel_welcome_messages);
            this.Controls.Add(this.panel_About);
            this.Controls.Add(this.monthCalendar);
            this.Controls.Add(this.panel_list_view_with_msg);
            this.Controls.Add(this.panel_outlookbar);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.Name = "FormMain";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Speaking Event Reminder";
            this.Closing += new System.ComponentModel.CancelEventHandler(this.FormMain_Closing);
            this.Load += new System.EventHandler(this.FormMain_Load);
            this.panel_list_view_with_msg.ResumeLayout(false);
            this.panel_list_view_with_msg.PerformLayout();
            this.panel_msg.ResumeLayout(false);
            this.panel_voice_option.ResumeLayout(false);
            this.panel_voice_option.PerformLayout();
            this.groupBoxSapi4.ResumeLayout(false);
            this.groupBox_user_voice_option.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.trackBar_speed)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.trackBar_pitch)).EndInit();
            this.panel_welcome_messages.ResumeLayout(false);
            this.panel_welcome_messages.PerformLayout();
            this.groupBox_startup_option_start.ResumeLayout(false);
            this.groupBox_startup_option_start.PerformLayout();
            this.groupBox1.ResumeLayout(false);
            this.groupBox2.ResumeLayout(false);
            this.groupBox2.PerformLayout();
            this.panel_Voice_Help.ResumeLayout(false);
            this.panel_Voice_Help.PerformLayout();
            this.panel_About.ResumeLayout(false);
            this.panel_About.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.pictureBox1)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Point d'entre principal de l'application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
#if !DEBUG
			try // catch all uncatched exception
			{
#endif
                Application.EnableVisualStyles();
				current_form_main=new FormMain();
				Application.Run(current_form_main);
#if !DEBUG
			}
			catch (Exception e)
			{
				System.Windows.Forms.MessageBox.Show( "The Following error has occured:\r\n"+e.Message+"\r\n Stack trace:\r\n"+e.StackTrace+"\r\n Application will be stopped",
					"Error",
					System.Windows.Forms.MessageBoxButtons.OK,
					System.Windows.Forms.MessageBoxIcon.Error);
			}
#endif
		}

        private void SetHelpText()
        {
            this.textBox_Voice_Help.Text = 
                            "System Requirements for Windows 8 or newer :\r\n"
                            + "\t- Double Agent Control (included in setup)\r\n"
                            + "\t- At least one Character (.acs file)\r\n"
                            + "\t- Voices : SAPI 5 voices\r\n"
                            + "\r\n"

                            + "System Requirements for Windows Vista / Seven:\r\n"
                            + "\t- Ms Agent activeX Control (included in setup)\r\n"
                            + "\t- At least one Character (.acs file)\r\n"
                            + "\t- Voices : SAPI 4 or SAPI 5 voices\r\n"
                            + "\r\n"
                            
                            + "System Requirements for Windows XP:\r\n"
                            + "\t- Text-to-Speech Engine (1-3 MB depending on langage)\r\n"
                            + "\t- SAPI 4.0 runtime support (824KB) (spchapi.exe)\r\n"
                            + "\t- At least one Character (.acs file)\r\n"
                            + "\t- Voices : a language or SAPI 4 voices\r\n"
                            + "\r\n"

                            + "Specific System Requirements for Windows 95/98/NT/2000 users :\r\n"
                            + "\t- Internet Explorer 4.0 or Above \r\n"
                            + "\t- MS Agent 2.0 Control (395 KB) (MSagent.exe)\r\n"
                            + "\t- Text-to-Speech Engine (1-3 MB depending on langage)\r\n"
                            + "\t- SAPI 4.0 runtime support (824KB) (spchapi.exe)\r\n"
                            + "\t- At least one Character (.acs file)\r\n"
                            + "\t- Voices : a language or SAPI 4 voices"
                            + "\r\n"
                            + "\r\n"
                            + "For more information or download link, go to http://jacquelin.potier.free.fr/eventreminder/#agent_info";
        }

		private void FormMain_Load(object sender, System.EventArgs e)
		{
			this.the_main=new class_main();
            this.SetHelpText();

			string [] cmd_args;

			cmd_args=System.Environment.GetCommandLineArgs();
			if (cmd_args.Length>1)
			{
				if (cmd_args[1]=="/run")
				{
					// hide form
					this.WindowState=System.Windows.Forms.FormWindowState.Minimized;
					this.ShowInTaskbar=false;
					// check for events
					this.the_main.event_dates_check();
					return;
				}
			}
			
			// cmd_args.Length<1 or cmd_args[1]!="/run" run in option mode

			// change location properties of controls
			this.monthCalendar.CalendarDimensions=new System.Drawing.Size(4,3);
			this.monthCalendar.Location=new System.Drawing.Point(100,0);
			this.panel_voice_option.Location=new System.Drawing.Point(100,0);
			this.panel_list_view_with_msg.Location=new System.Drawing.Point(100,0);
			this.panel_welcome_messages.Location=new System.Drawing.Point(100,0);
			this.panel_About.Location=new System.Drawing.Point(100,0);
			this.panel_Voice_Help.Location=new System.Drawing.Point(100,0);


			
			
			// show / Hide controls
			this.panel_list_view_with_msg.Visible=false;
			this.panel_voice_option.Visible=false;
			this.panel_welcome_messages.Visible=false;
			this.panel_About.Visible=false;
			this.panel_Voice_Help.Visible=false;

			this.monthCalendar.Visible=true;
			
			// add controls from utility library
			this.the_main.event_dates_configuration();
			// make Xp style to button
			Class_MakeXPStyle.MakeXPStyle(this);
			// add event
			outlookbar.ItemClicked += new UtilityLibrary.WinControls.OutlookBarItemClickedHandler(outlookbar_ItemClicked);
			

            System.OperatingSystem osInfo = System.Environment.OSVersion;
            /*
            +------------------------------------------------------------------------------+
            |                    |   PlatformID    |   Major version   |   Minor version   |
            +------------------------------------------------------------------------------+
            | Windows 95         |  Win32Windows   |         4         |          0        |
            | Windows 98         |  Win32Windows   |         4         |         10        |
            | Windows Me         |  Win32Windows   |         4         |         90        |
            | Windows NT 4.0     |  Win32NT        |         4         |          0        |
            | Windows 2000       |  Win32NT        |         5         |          0        |
            | Windows XP         |  Win32NT        |         5         |          1        |
            | Windows 2003       |  Win32NT        |         5         |          2        |
            | Windows Vista      |  Win32NT        |         6         |          0        |
            | Windows 2008       |  Win32NT        |         6         |          0        |
            | Windows 7          |  Win32NT        |         6         |          1        |
            | Windows 2008 R2    |  Win32NT        |         6         |          1        |
            | Windows 8          |  Win32NT        |         6         |          2        |
            | Windows 8.1        |  Win32NT        |         6         |          3        |
            +------------------------------------------------------------------------------+
            | Windows 10         |  Win32NT        |        10         |          0        |
            +------------------------------------------------------------------------------+
             */

            // langage no more supported since Vista
            if (osInfo.Version.Major >= 6)
            {
                // hide language
                this.labelLanguage.Hide();
                this.comboBox_language.Hide();
            }

            // let sapi 4 and 5 only for 7

            // if Os higher than 7 hide sapi 4
            if ( (osInfo.Version.Major >= 6) && (osInfo.Version.Minor >= 2) )
            {
                // hide sapi 4 for Os supporting SAPI 5
                this.groupBoxSapi4.Hide();
                this.labelSAPI4Voices.Hide();
                this.comboBox_ttsengine.Hide();
                // hide sapi 5 too as test to speech setting are only configured from control panel for win 8+
                this.labelSAPI5Voices.Hide();
                this.comboBox_sapi5_voices.Hide();
                this.labelSapiWin8Plusinfos.Show();
            }

            // if Os lower than win 7 hide sapi 5
            else if (       (osInfo.Version.Major < 6 ) 
                        ||  ( (osInfo.Version.Major == 6 ) && (osInfo.Version.Minor < 1) )
                    )
            {
                // hide sapi 5 for Os not supporting SAPI 5
                this.labelSAPI5Voices.Hide();
                this.comboBox_sapi5_voices.Hide();
            }
		}


		private void FormMain_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			this.the_main.shutdown();
			this.the_main.options.save();
		}


		#region outlook bar events

		private void outlookbar_ItemClicked(UtilityLibrary.WinControls.OutlookBarBand band, UtilityLibrary.WinControls.OutlookBarItem item)
		{
			switch(item.Text)
			{
				case "Calendar":
					this.panel_list_view_with_msg.Visible=false;
					this.panel_voice_option.Visible=false;
					this.panel_welcome_messages.Visible=false;
					this.panel_About.Visible=false;
					this.panel_Voice_Help.Visible=false;

					this.monthCalendar.Visible=true;
					break;
				case "Events List":
					this.monthCalendar.Visible=false;
					this.panel_voice_option.Visible=false;
					this.panel_welcome_messages.Visible=false;
					this.panel_About.Visible=false;
					this.panel_Voice_Help.Visible=false;

					this.panel_list_view_with_msg.Visible=true;
					break;
				case "Voice Options":
					this.monthCalendar.Visible=false;
					this.panel_list_view_with_msg.Visible=false;
					this.panel_welcome_messages.Visible=false;
					this.panel_About.Visible=false;
					this.panel_Voice_Help.Visible=false;

					this.panel_voice_option.Visible=true;
					this.initialize_panel_option();
					break;
				case "Startup Options":
					this.monthCalendar.Visible=false;
					this.panel_list_view_with_msg.Visible=false;
					this.panel_voice_option.Visible=false;
					this.panel_About.Visible=false;
					this.panel_Voice_Help.Visible=false;

					this.panel_welcome_messages.Visible=true;
					this.initialize_panel_startup_options();
					break;
				case "Voice Help":
					this.monthCalendar.Visible=false;
					this.panel_welcome_messages.Visible=false;
					this.panel_list_view_with_msg.Visible=false;
					this.panel_voice_option.Visible=false;
					this.panel_About.Visible=false;

					this.panel_Voice_Help.Visible=true;
					break;
				case "About":
					this.panel_voice_option.Visible=false;
					this.panel_welcome_messages.Visible=false;
					this.monthCalendar.Visible=false;
					this.panel_list_view_with_msg.Visible=false;
					this.panel_Voice_Help.Visible=false;

					this.panel_About.Visible=true;

					break;
				default:
					break;
			}
			/*
			band.Text 
			item.Text 
			*/
		}

		#endregion

		#region voice options

		private bool panel_option_initialized;

		private void button_browse_agent_name_Click(object sender, System.EventArgs e)
		{
			if (openFileDialog.ShowDialog(this)==DialogResult.OK)
			{
                string AgentFilePath = openFileDialog.FileName;
                // try to make relative path
                string ExeFilePath = System.Windows.Forms.Application.ExecutablePath;
                string Dir = System.IO.Path.GetDirectoryName(ExeFilePath);
                if (AgentFilePath.StartsWith(Dir))
                {
                    AgentFilePath = AgentFilePath.Substring(Dir.Length);
                    if (AgentFilePath.StartsWith("\\") || AgentFilePath.StartsWith("//"))
                        AgentFilePath = AgentFilePath.Substring(1);
                }

				// check that the agent name is different of the current one
                if (this.textBox_agent_name.Text == AgentFilePath) 
                    return;
				// update interface
                this.textBox_agent_name.Text = AgentFilePath;
				// change options in memory
                this.the_main.options.agent_name = AgentFilePath;
				// unload current agent
				this.the_main.clagent.unload_agent();
				// load new agent and apply current settings
				this.the_main.load_agent_and_apply_settings();
				// show the agent
				this.the_main.clagent.obj_char_ex.Show(false);
				// allow to save
				this.button_ok.Enabled=true;
			}
		}

		private void checkBox_ballon_checked_changed(object sender, System.EventArgs e)
		{
			// update option in memory
			this.the_main.options.ballon_on=this.checkBox_ballon.Checked;
			// apply changes
			this.the_main.clagent.show_ballon(this.the_main.options.ballon_on);

            //if (this.the_main.options.ballon_on)
            //{
            //    this.the_main.clagent.speak("Balloon added");
            //}
            //else
            //{
            //    this.the_main.clagent.speak("Balloon removed");
            //}
		}


		// for radioButton_following_options and radioButton_default_voice_option
		private void radioButton_following_options_Checked_Changed(object sender, System.EventArgs e)
		{
			// update option in memory
			this.the_main.options.default_voice=!(this.radioButton_following_options.Checked);
			// apply changes
			this.the_main.clagent.default_voice=this.the_main.options.default_voice ;
			// enable/disable controls
			this.groupBox_user_voice_option.Enabled=!(this.the_main.options.default_voice);
			// allow to save
			this.button_ok.Enabled=true;
		}
		private void comboBox_context_output_text_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (!panel_option_initialized) return;
			// update option in memory
			this.the_main.options.voice_context=comboBox_context_output_text.Text;
			// apply changes
			this.the_main.clagent.ctxtag=this.the_main.options.voice_context;
			// allow to save
			this.button_ok.Enabled=true;
		}

		private void trackBar_pitch_Scroll(object sender, System.EventArgs e)
		{
			// update option in memory
			this.the_main.options.voice_pitch=this.trackBar_pitch.Value;
			// apply changes
			this.the_main.clagent.pittag=this.the_main.options.voice_pitch;
			// allow to save
			this.button_ok.Enabled=true;
		}

		private void trackBar_speed_Scroll(object sender, System.EventArgs e)
		{
			// update option in memory
			this.the_main.options.voice_speed=this.trackBar_speed.Value;
			// apply changes
			this.the_main.clagent.spdtag=this.the_main.options.voice_speed;
			// allow to save
			this.button_ok.Enabled=true;
		}

        private void comboBox_character_voice_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            if (!panel_option_initialized) return;
            // update option in memory
            this.the_main.options.voice_character = comboBox_character_voice.Text;
            // apply changes
            this.the_main.clagent.chrtag = this.the_main.options.voice_character;
            // allow to save
            this.button_ok.Enabled = true;
        }
        private void comboBox_language_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            if (!panel_option_initialized) return;
            // update option in memory
            this.the_main.options.language = this.comboBox_language.Text;
            // apply changes
            this.the_main.options.engine_type = class_options.tag_engine_type.engine_type_language;
            this.the_main.clagent.change_language(this.the_main.options.language);
            // allow to save
            this.button_ok.Enabled = true;
        }

        private void comboBox_ttsengine_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            if (!panel_option_initialized) return;
            // update option in memory
            this.the_main.options.tts_engine = this.comboBox_ttsengine.Text;
            // apply changes
            this.the_main.options.engine_type = class_options.tag_engine_type.engine_type_TTS_SAPI4;
            this.the_main.clagent.change_tts_engine_from_description(this.the_main.options.tts_engine);
            // allow to save
            this.button_ok.Enabled = true;
        }

        private void comboBox_sapi5_voices_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (!panel_option_initialized) return;
            // update option in memory
            this.the_main.options.SAPI5_tts_engine = this.comboBox_sapi5_voices.Text;
            // apply changes
            this.the_main.options.engine_type = class_options.tag_engine_type.engine_type_TTS_SAPI5;

            System.Speech.Synthesis.SpeechSynthesizer Synthesizer = new System.Speech.Synthesis.SpeechSynthesizer();
            System.Collections.ObjectModel.ReadOnlyCollection<System.Speech.Synthesis.InstalledVoice> InstalledVoices = Synthesizer.GetInstalledVoices();
            foreach (System.Speech.Synthesis.InstalledVoice Voice in InstalledVoices)
            {
                if (Voice.VoiceInfo.Name == this.comboBox_sapi5_voices.Text)
                {
                    this.the_main.clagent.change_tts_engine(Voice.VoiceInfo.Name); // on sapi 5 tts engine id is the name
                }
            }
            
            // allow to save
            this.button_ok.Enabled = true;
        }

		private void initialize_panel_option()
		{
			panel_option_initialized=false;
			// fill interface with options

            // fill sapi 5
            System.Speech.Synthesis.SpeechSynthesizer Synthesizer = new System.Speech.Synthesis.SpeechSynthesizer();
            System.Collections.ObjectModel.ReadOnlyCollection<System.Speech.Synthesis.InstalledVoice> InstalledVoices = Synthesizer.GetInstalledVoices();
            this.comboBox_sapi5_voices.Items.Clear();
            foreach (System.Speech.Synthesis.InstalledVoice Voice in InstalledVoices)
            {
                this.comboBox_sapi5_voices.Items.Add(Voice.VoiceInfo.Name);
            }
            this.comboBox_sapi5_voices.Text = this.the_main.options.SAPI5_tts_engine;

            // fill language
            this.comboBox_language.Items.Clear();
            for (int cpt = 0; cpt < class_language_and_tts_engine.array_language.Length; cpt++)
                this.comboBox_language.Items.Add(class_language_and_tts_engine.array_language[cpt].name);
            this.comboBox_language.Text = this.the_main.options.language;

            // fill sapi 4
            this.comboBox_ttsengine.Items.Clear();
            for (int cpt = 0; cpt < class_language_and_tts_engine.array_ttsmode.Length; cpt++)
                this.comboBox_ttsengine.Items.Add(class_language_and_tts_engine.array_ttsmode[cpt].name);
            this.comboBox_ttsengine.Text = this.the_main.options.tts_engine;

            System.OperatingSystem osInfo = System.Environment.OSVersion;
            if (osInfo.Version.Major >= 6)
            {
                this.comboBox_language.Enabled = false;
            }

			this.radioButton_default_voice_option.Checked=this.the_main.options.default_voice;
			this.radioButton_following_options.Checked=!(this.the_main.options.default_voice);
			this.groupBox_user_voice_option.Enabled=!(this.the_main.options.default_voice);
			this.trackBar_pitch.Value=this.the_main.options.voice_pitch;
			this.trackBar_speed.Value=this.the_main.options.voice_speed;

			this.comboBox_character_voice.Items.AddRange(class_language_and_tts_engine.array_voice_character);
			this.comboBox_context_output_text.Items.AddRange(class_language_and_tts_engine.array_voice_context);
			this.comboBox_character_voice.Text=this.the_main.options.voice_character;
			this.comboBox_context_output_text.Text=this.the_main.options.voice_context;
			panel_option_initialized=true;
		}

		private void button_test_Click(object sender, System.EventArgs e)
		{
			this.the_main.clagent.speak(this.textBox_voice_test.Text);
		}

		private void quit_panel_option()
		{
			// unload agent and forget settings
			this.the_main.clagent.unload_agent();
			// calling the load methode restores original settings
			this.the_main.start_agent();
			this.the_main.clagent.obj_char_ex.Show(false);
			// restore interface after settings are restored
			initialize_panel_option();
		}

		private void button_cancel_Click(object sender, System.EventArgs e)
		{
			quit_panel_option();
		}

		private void button_ok_Click(object sender, System.EventArgs e)
		{
			// save options
			this.the_main.options.save();
			this.button_ok.Enabled=false;
			//
			this.the_main.clagent.play("Write");
			this.the_main.clagent.play("WriteReturn");
		}

		#endregion

		#region event management

		private void button_edit_selected_Click(object sender, System.EventArgs e)
		{
			single_event single_event;
			single_event[] array_single_event;
			FormEventEdit fee=new FormEventEdit();

			// get selected item
			System.Windows.Forms.ListView.SelectedListViewItemCollection slvic=this.listView_event.SelectedItems;
			//find corresponding event
			switch (slvic.Count)
			{
				case 0:
					return;
				case 1:
					single_event=this.the_main.find_event_with_name_date_event(slvic[0].Text,slvic[0].SubItems[1].Text,slvic[0].SubItems[2].Text);
					fee.event_to_edit(single_event);
					break;
				default:
					array_single_event=new single_event[slvic.Count];
					for (int cpt=0;cpt<slvic.Count;cpt++)
						array_single_event[cpt]=this.the_main.find_event_with_name_date_event(slvic[cpt].Text,slvic[cpt].SubItems[1].Text,slvic[cpt].SubItems[2].Text);
					fee.event_to_edit(array_single_event);
					break;
			}

			// show event window
			fee.ShowDialog();
		}

		private void button_add_Click(object sender, System.EventArgs e)
		{
			FormEventEdit fee=new FormEventEdit();
			fee.ShowDialog();
		}

		private void button_remove_selected_Click(object sender, System.EventArgs e)
		{
			single_event thesingle_event;
			single_event[] array_single_event;

			// get selected item
			System.Windows.Forms.ListView.SelectedListViewItemCollection slvic=this.listView_event.SelectedItems;
			//find corrsponding event
			switch (slvic.Count)
			{
				case 0:
					return;
				case 1:
					thesingle_event=this.the_main.find_event_with_name_date_event(slvic[0].Text,slvic[0].SubItems[1].Text,slvic[0].SubItems[2].Text);
					this.the_main.remove_event(thesingle_event);
					break;
				default:
					array_single_event=new single_event[slvic.Count];
					for (int cpt=slvic.Count-1;cpt>-1;cpt--)// slvic is updated after each remove
					{
						array_single_event[cpt]=this.the_main.find_event_with_name_date_event(slvic[cpt].Text,slvic[cpt].SubItems[1].Text,slvic[cpt].SubItems[2].Text);
						this.the_main.remove_event(array_single_event[cpt]);
					}
					break;
			}
		}

		private void Button_listview_with_msg_apply_Click(object sender, System.EventArgs e)
		{
			this.the_main.options.play_message_if_noevent_at_windows_startup=this.checkBox_message_if_no_event.Checked;
			this.the_main.options.no_event_speech=this.textBox_no_event_in_the_following_days.Text;
			this.the_main.options.n_days_before_event=this.textBox_speech_n_days_before.Text;
			this.the_main.options.save();
			this.the_main.clagent.play("Write");
			this.the_main.clagent.play("WriteReturn");
		}

		#endregion

		#region startup options

		private void button_add_messages_Click(object sender, System.EventArgs e)
		{
			// add to listbox
			this.listBox_welcome_messages.Items.Add(this.textBox_welcome_message.Text);
			// add to memory
			this.the_main.clwelcome_messages.messages.Add(this.textBox_welcome_message.Text);
			// save
			this.the_main.clwelcome_messages.save();
		}

		private void button_remove_selected_message_Click(object sender, System.EventArgs e)
		{
			System.Windows.Forms.ListBox.SelectedObjectCollection lsoc;
			lsoc=this.listBox_welcome_messages.SelectedItems;
			string stritem;
			for (int cpt=lsoc.Count-1;cpt>-1;cpt--)
			{
				//stritem=(string)lsoc[cpt];//.ToString()
				stritem=lsoc[cpt].ToString();
				// remove from listbox
				this.listBox_welcome_messages.Items.Remove(lsoc[cpt]);
				// remove from memory
				this.the_main.clwelcome_messages.messages.Remove(stritem);
			}

            // save
            this.the_main.clwelcome_messages.save();
		}

		private void checkBox_welcome_message_at_startup_CheckedChanged(object sender, System.EventArgs e)
		{
			this.the_main.options.play_welcome_message=this.checkBox_welcome_message_at_startup.Checked;
		}

		private bool check_if_numbers_only(TextBox txtbox,ref ushort us_value)
		{
			// Determine if the text of the control is a number.
			try 
			{
				// Attempt to convert to long
				us_value = System.Convert.ToUInt16(txtbox.Text);
			}
			catch 
			{
				// Display a message box and clear the contents if not a number.
				MessageBox.Show("Not a valid number. Please enter valid numbers");
				// Clear the contents of the text box to allow re-entry.
				txtbox.Clear();
				return false;
			}
			return true;

		}

		private void button_startup_option_apply_Click(object sender, System.EventArgs e)
		{
			ushort us=0;
		    this.the_main.options.shortcut_launch=this.radioButton_run_at_startup.Checked;
			if (this.the_main.options.shortcut_launch)
			{
				// check if short cut exist and create if necessary
				this.the_main.create_or_restore_shortcut();
			}
			else
			{
				// check 3 boxes
				if (!this.check_if_numbers_only(this.textBox_startup_options_days_interval,ref us))
                    return;
				this.the_main.options.task_day_interval=us;
				if (!this.check_if_numbers_only(this.textBox_startup_options_hour,ref us))
                    return;
				this.the_main.options.task_start_hour=us;
				if (!this.check_if_numbers_only(this.textBox_startup_options_min,ref us))
                    return;
				this.the_main.options.task_start_min=us;
				// create windows task
                if (!this.the_main.create_or_restore_windows_task(true))
                    return;
			}
            this.the_main.options.save();
            this.the_main.clagent.play("Write");
            this.the_main.clagent.play("WriteReturn");
		}
		private void initialize_panel_startup_options()
		{
            this.textBox_agent_name.Text = this.the_main.options.agent_name;
            this.checkBox_ballon.Checked = this.the_main.options.ballon_on;
			this.textBox_startup_options_days_interval.Text=this.the_main.options.task_day_interval.ToString();
			this.textBox_startup_options_hour.Text=this.the_main.options.task_start_hour.ToString();
			this.textBox_startup_options_min.Text=this.the_main.options.task_start_min.ToString();
			this.radioButton_run_at_startup.Checked=this.the_main.options.shortcut_launch;
			this.radioButton_run_with_windows_task.Checked=!this.radioButton_run_at_startup.Checked;
		}
		#endregion

		private void monthCalendar_DateSelected(object sender, System.Windows.Forms.DateRangeEventArgs e)
		{
			single_event[] array_single_event;
			array_single_event=this.the_main.find_event_with_date(new date_event(this.monthCalendar.SelectionStart.Month,this.monthCalendar.SelectionStart.Day));
			string msg="";
			if (array_single_event.Length==0) return;
			for (int cpt=0;cpt<array_single_event.Length;cpt++)
			{
				if (cpt>0) msg+="\r\n";
				msg+=array_single_event[cpt].event_description;
			}

			Balloon.NET.BalloonHelp ballon_help=new Balloon.NET.BalloonHelp();
			ballon_help.Caption="Event(s)";
			ballon_help.Content=msg;
			ballon_help.Icon=this.Icon;
			System.Drawing.Point cur_pos;
			cur_pos=System.Windows.Forms.Cursor.Position;
			ballon_help.AnchorPoint=cur_pos;
			ballon_help.EnableTimeout=true;
			ballon_help.Timeout=2000;
			ballon_help.Show();
		}

		private void linkLabel_mail_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			System.Windows.Forms.LinkLabel linkLabel_mail=(System.Windows.Forms.LinkLabel) sender;
			// change color of link
			linkLabel_mail.LinkVisited = true;
			// open mail soft
			string mail;
			mail=linkLabel_mail.Text;
			System.Diagnostics.Process.Start("mailto:"+mail);
		}

	}
}
