#include "HotFixes.h"

#include <Wuapi.h>

BOOL CHotFixes::IsHotFixInstalled(WCHAR* HotFix)
{
	int RetValue = FALSE;
    IUpdateSession* lpUpdateSession = NULL;
    IUpdateSearcher* lpUpdateSearcher = NULL;
    //ISearchResult* lpInstalledUpdatesSearch = NULL;
    //IUpdateCollection* lpInstalledUpdates = NULL;
	HRESULT ret;
	

#ifdef _DEBUG
    WCHAR MsgDebug[MAX_PATH];
#endif

	ret = CoCreateInstance(CLSID_UpdateSession, NULL, CLSCTX_INPROC_SERVER, IID_IUpdateSession, (LPVOID*)&lpUpdateSession);
	if( FAILED(ret) || (lpUpdateSession == NULL) )
		goto CleanUp;

	ret = lpUpdateSession->CreateUpdateSearcher(&lpUpdateSearcher);
	if( FAILED(ret) || (lpUpdateSearcher == NULL) )
		goto CleanUp;

    // ask to work off line
	lpUpdateSearcher->put_Online(VARIANT_FALSE);// This call returns E_ACCESSDENIED if IE is in protected mode

	LONG lHistoryCount;
	ret = lpUpdateSearcher->GetTotalHistoryCount(&lHistoryCount);
	if (FAILED(ret) || (lHistoryCount == 0))
		goto CleanUp;

	IUpdateHistoryEntryCollection* pUpdateHistoryEntryCollection = NULL;
	ret = lpUpdateSearcher->QueryHistory(0,lHistoryCount,&pUpdateHistoryEntryCollection);
	if( FAILED(ret) || (pUpdateHistoryEntryCollection == NULL) )
		goto CleanUp;

	IUpdateHistoryEntry* pUpdateHistoryEntry;
	for (LONG Cnt = 0; Cnt< lHistoryCount; Cnt++)
	{
		pUpdateHistoryEntry = NULL;
		pUpdateHistoryEntryCollection->get_Item(Cnt,&pUpdateHistoryEntry);
		if( FAILED(ret) || (pUpdateHistoryEntry == NULL) )
			continue;

			BSTR bstrTitle;
			// pUpdateHistoryEntry->get_ClientApplicationID(&bstrKB); // no use guid
			// pUpdateHistoryEntry->get_ServiceID(&bstrKB); // no use guid

			pUpdateHistoryEntry->get_Title(&bstrTitle);
			if (!bstrTitle)
				continue;

#ifdef _DEBUG
            _snwprintf(MsgDebug,MAX_PATH,_T("KB %s\r\n"),bstrTitle);
            OutputDebugStringW(MsgDebug);
#endif
			// check for searched string
			if (wcsstr(bstrTitle,HotFix))
			{
				::SysFreeString(bstrTitle);
				RetValue = TRUE;
				break;
			}
			::SysFreeString(bstrTitle);

		pUpdateHistoryEntry->Release();
	}
	pUpdateHistoryEntryCollection->Release();


//    // search for installed updates 
//	// this list only system updates update with "Microsoft Windows" in there name, if there's only KBXXXX in name, it is not listed
//
//	WCHAR* SmallHotFixName;
//
//	SmallHotFixName = HotFix;
//	if (wcslen(HotFix)>2)
//	{
//		if ( wcsnicmp(HotFix,L"KB",2) ==0 )
//		{
//			SmallHotFixName = &HotFix[2];
//		}
//	}
//
//
//	BSTR SearchedBstr = ::SysAllocString(L"IsInstalled=1"); 
//	ret = lpUpdateSearcher->Search(SearchedBstr,&lpInstalledUpdatesSearch);
//	::SysFreeString(SearchedBstr);
//	if( FAILED(ret) || (lpInstalledUpdatesSearch == NULL) )
//		goto CleanUp;
//
//	OperationResultCode SearchResultCode;
//	lpInstalledUpdatesSearch->get_ResultCode(&SearchResultCode);
//	if(orcSucceeded == SearchResultCode)
//	{
//		ret = lpInstalledUpdatesSearch->get_Updates(&lpInstalledUpdates);
//		if( FAILED(ret) || (lpInstalledUpdates == NULL ) )
//			goto CleanUp;
//
//		long lInstalledUpdatesCount;
//		lpInstalledUpdates->get_Count(&lInstalledUpdatesCount);
//
//#ifdef _DEBUG
//        _snwprintf(MsgDebug,MAX_PATH,L"Installed updates count = %ld\r\n",lInstalledUpdatesCount);
//        OutputDebugStringW(MsgDebug);
//#endif
//
//        // for each InstalledUpdates
//		for(long i = 0; i<  lInstalledUpdatesCount; i++)
//		{
//			IUpdate *lpUpdate;
//			ret = lpInstalledUpdates->get_Item(i,&lpUpdate);
//			if(SUCCEEDED(ret) &&  lpUpdate )
//			{
//				//BSTR _bstrTitle;
//				//lpUpdate->get_Title(&_bstrTitle);
//				//bstr_t bstrTitle(_bstrTitle);
//				IStringCollection *lpKBArticles;
//				ret = lpUpdate->get_KBArticleIDs(&lpKBArticles);
//				if(SUCCEEDED(ret) &&  lpKBArticles )
//				{
//					long lKBArticlesCount;
//					lpKBArticles->get_Count(&lKBArticlesCount);
//					for(long kb = 0; kb<  lKBArticlesCount; kb++)
//					{
//						BSTR bstrKB;
//						lpKBArticles->get_Item(kb,&bstrKB);
//						if (!bstrKB)
//							continue;
//
//#ifdef _DEBUG
//                        _snwprintf(MsgDebug,MAX_PATH,_T("KB %s\r\n"),bstrKB);
//                        OutputDebugStringW(MsgDebug);
//#endif
//						// check for searched string
//						if (wcsicmp(SmallHotFixName,bstrKB)==0)
//						{
//							::SysFreeString(bstrKB);
//							RetValue = TRUE;
//							break;
//						}
//
//						::SysFreeString(bstrKB);
//					}// end for
//
//                    lpKBArticles->Release();
//				}
//
//                lpUpdate->Release();
//			}
//		}// ends for each InstalledUpdates
//
//		lpInstalledUpdates->Release();
//	}
//	lpInstalledUpdatesSearch->Release();
//
//
//	lpUpdateSearcher->Release();
//	lpUpdateSession->Release();

    return RetValue;

CleanUp:
    //if (lpInstalledUpdates)
    //    lpInstalledUpdates->Release();
    //if (lpInstalledUpdatesSearch)
    //    lpInstalledUpdatesSearch->Release();
    if (lpUpdateSearcher)
        lpUpdateSearcher->Release();
    if (lpUpdateSession)
        lpUpdateSession->Release();

	return RetValue;
}